version: v2beta1
name: growth-api

dev:
  app:
    labelSelector:
      app.kubernetes.io/name: ${DEVSPACE_NAME}
      app.kubernetes.io/instance: ${DEVSPACE_NAME}
    container: go
    devImage: ghcr.io/loft-sh/devspace-containers/go:1.18-alpine

    ports:
      - port: "8080"
      - port: "8082"
      - port: "8084"
      - port: "8085" # debugger port

    ssh:
      enabled: true
      useInclude: false

    proxyCommands:
      - command: kubectl
      - command: make

    # Hot reloads (actually whole restart)
    command: [
        "dlv", # run debugger
        "debug",
        # "--log",
        # "--log-output=debugger,gdbwire,lldbout,debuglineerr,rpc,dap,fncall,minidump",
        "--headless",
        "--accept-multiclient",
        "--api-version=2",
        "--listen=:8085", # debugger port
        "--continue", # uncomment to start the program asap not waiting for debugger client (IDE) to connect
        "./cmd", # package to run
      ]

    # Sync files between the local filesystem and the development container
    sync:
      - path: ../:./
        excludeFile: .gitignore
        excludePaths:
          - .cfg/devspace.yaml
          - .git/
          - .gitlab/
        onUpload:
          restartContainer: true
      - path: ${HOME}/.netrc:/root/.netrc
        disableDownload: true

    # Override resources to allow go building use more memory
    resources:
      requests:
        cpu: 500m
        memory: 512Mi
      limits:
        cpu: "4"
        memory: 4Gi

    # Use helper to act as entrypoint. This way only the command will be restarted, not the whole container
    restartHelper:
      inject: true

    # Stream logs
    logs:
      lastLines: 20
